// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/base"
	model "LAPP_ACURA_MOM_BACKEND/models/base"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : WorkPlaceDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : WorkPlace的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-21 10:27:00
 *
 ******************************************************************************/
type WorkPlaceDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewWorkPlaceDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个WorkPlaceDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : WorkPlaceDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-21 10:27:00
 *
 ******************************************************************************/
func NewWorkPlaceDAOImplement(session *xorm.Session, plantNr int, userid string) *WorkPlaceDAOImplement {
	return &WorkPlaceDAOImplement{session, &meta.WorkPlace, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.InsertOne
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) InsertOne(entity *model.WorkPlace) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) DeleteOne(workPlaceNr int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, workPlaceNr}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.SelectOne
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) SelectOne(workPlaceNr int) (*model.WorkPlace, error) {
	var data model.WorkPlace
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, workPlaceNr}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.SelectById
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) SelectById(workPlaceId string) (*model.WorkPlace, error) {
	var data model.WorkPlace
	ok, err := impl.session.Table(impl.meta.TableName).Where("PlantNr = ? and WorkPlaceId = ?", impl.plantNr, workPlaceId).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) UpdateOne(entity *model.WorkPlace) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.Insert
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) Insert(entities *[]model.WorkPlace) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.Delete
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) Delete(entities *[]model.WorkPlace) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkPlace_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.Select
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WorkPlace, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkPlace_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.WorkPlace_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.WorkPlace, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkPlace_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.WorkPlace_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.WorkPlace, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.Update
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) Update(entities *[]model.WorkPlace) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.WorkPlace, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.WorkPlace_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.WorkPlace_LastUser.Name)
	entity.LastUser = impl.userid
	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/WorkPlaceDAO.SelectByWorkLineId
 *
 ******************************************************************************/
func (impl *WorkPlaceDAOImplement) SelectByWorkLineId(workLineId string) (*[]model.WorkPlace, error) {
	result := make([]model.WorkPlace, 0, 10)
	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ? and %s = ?", meta.WorkPlace_PlantNr.ColumnName, meta.WorkLineWorkPlaceLst_WorkLineId.ColumnName)
	condition := fmt.Sprintf("%s = %s and %s = %s",
		meta.WorkPlace_PlantNr.ColumnName,
		meta.WorkLineWorkPlaceLst_PlantNr.ColumnName,
		meta.WorkPlace_WorkPlaceNr.ColumnName,
		meta.WorkLineWorkPlaceLst_WorkPlaceNr.ColumnName)
	parameters = append(parameters, workLineId)
	err := impl.session.Table(impl.meta.TableName).Join("LEFT", meta.WorkLineWorkPlaceLst.TableName, condition).Where(where, parameters...).Asc(meta.WorkLineWorkPlaceLst_Pos.ColumnName).Find(&result)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return &result, nil
}
